VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ClsCryptage"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
'variables locales de stockage des valeurs de proprits

Public Enum TypeOp
    Cryptage = 0
    deCryptage = 1
End Enum

Private mvarTypeTravail As TypeOp 'copie locale
Private mvarTxtCryptEnvoi As String 'copie locale
Private mvarMotCle As String 'copie locale

Public Function TxtCryptRetour() As String

Dim TxtTrav As String

Select Case mvarTypeTravail

    Case 0   ' cryptage
        TxtTrav = FctCryptage
                
    Case 1   ' decrytptage
        TxtTrav = FctDecryptage
        
End Select

TxtCryptRetour = TxtTrav

End Function

Public Property Let TxtCryptEnvoi(ByVal vdata As String)
'utilis lors de l'affectation d'une valeur  la proprit, du cot gauche de l'affectation.
'Syntax: X.TxtCryptEnvoi = 5
    mvarTxtCryptEnvoi = vdata
End Property


Public Property Get TxtCryptEnvoi() As String
'utilis lors de la lecture de la valeur de la proprit, du cot droit de l'instruction.
'Syntax: Debug.Print X.TxtCryptEnvoi
    TxtCryptEnvoi = mvarTxtCryptEnvoi
End Property

Public Property Let TypeTravail(ByVal vdata As TypeOp)
'utilis lors de l'affectation d'une valeur  la proprit, du cot gauche de l'affectation.
'Syntax: X.TypeTravail = 5
    mvarTypeTravail = vdata
End Property

Public Property Get TypeTravail() As TypeOp
'utilis lors de la lecture de la valeur de la proprit, du cot droit de l'instruction.
'Syntax: Debug.Print X.TypeTravail
    TypeTravail = mvarTypeTravail
End Property

Public Property Let MotCle(ByVal vdata As String)
'utilis lors de l'affectation d'une valeur  la proprit, du cot gauche de l'affectation.
'Syntax: X.MotCle = 5
    mvarMotCle = vdata
End Property

Public Property Get MotCle() As String
'utilis lors de la lecture de la valeur de la proprit, du cot droit de l'instruction.
'Syntax: Debug.Print X.MotCle
    MotCle = mvarMotCle
End Property

Private Function FctCryptage() As String

    Dim strCrypter As String
    Dim strCle As String
    Dim intTemp As Integer
    Dim intLongueureur As Integer
    
    Dim lng As Integer
    Dim y As Integer
    Dim i As Integer
    Dim w As Integer
    
    Dim tabCle() As String
    Dim tabAscii() As Integer
    Dim tabCryptage() As String
                   
    ' la Longueur du mot cl pass en appel  la classe
    intLongueureur = Len(mvarMotCle)
    
    ' allocation des variables
    strCrypter = Trim(mvarTxtCryptEnvoi)
    strCle = mvarMotCle
    lng = Len(strCrypter)
    
    ' redimensionnement des tableaux dclars prcedemment suivant la valeur calcule "intLongueureur du texte  crypter"
    ReDim tabCryptage(lng) As String
    ReDim tabAscii(lng) As Integer
    ReDim tabFinal(lng) As String
    ReDim tabCle(lng) As String
        
    ' Rapport entre la longueur du mot cl et la longueur du texte  crypter
    ' afin de dterminer combien de fois on doit "passer" le mot cl pour couvrir
    ' tout le texte  crypter
    intTemp = lng / intLongueureur
    
    ' Gnration en boucle du code Ascii des lettres du mot cl pour "couvrir" la
    ' longueur du teste  crypter
    For y = 0 To (intTemp)
        For i = 1 To intLongueureur
            w = (y * intLongueureur) + i
            If w <= lng Then ' arrter quand on a couvert toute la longueur du texte  crypter
                tabCle(w) = Mid(strCle, i, 1) '= "D"
                ' cration d'une table Ascii (tabCle) de mme longueur que le texte  crypter
                ' et traitement du "blanc" pouvant se trouver dans le mot cl
                If tabCle(w) = "" Then
                Else
                    tabCle(w) = Asc(tabCle(w)) '=Asc("D") = 68
                End If
            End If
        Next i
    Next y
    
    ' Combinaison du code Ascii de chaque caractre du texte  crypter avec le code Ascii de
    ' la table cre prcedemment (tabCle)
    For i = 1 To lng
        tabAscii(i) = Asc(Mid(strCrypter, i, 1))
        tabAscii(i) = tabAscii(i) + Val(tabCle(i))
        
        ' si la combinaison des codes Ascii dpasse la limite de la table des codes,
        ' on ramne le code Ascii <=  255
        If tabAscii(i) > 255 Then
            tabAscii(i) = tabAscii(i) - 255
        End If
        
        'reconstruction d'un string bas sur les codes Ascii combins
        FctCryptage = FctCryptage + Chr(tabAscii(i))
    Next i
       
End Function
Private Function FctDecryptage() As String

    Dim strDecrypter As String
    Dim strCle As String

    Dim intTemp As Integer
    Dim intLongueur As Integer
    Dim lng As Integer

    'Cration des tableaux
    Dim tabCle() As String
    Dim tabDecryptage() As String
    Dim tabAscii() As Integer
    'Dim tabFinal() As String
          
  
    intLongueur = Len(mvarMotCle)
    strDecrypter = mvarTxtCryptEnvoi
    lng = Len(strDecrypter)
        
    ReDim tabDecryptage(lng) As String
    ReDim tabAscii(lng) As Integer
 '  ReDim tabFinal(lng) As String
    ReDim tabCle(lng) As String
    
    For i = 1 To lng
        tabDecryptage(i) = Mid(strDecrypter, i, 1)
    Next
      
    strCle = mvarMotCle
    intTemp = lng \ intLongueur
    For y = 0 To intTemp
        For i = 1 To intLongueur
            w = (y * intLongueur) + i
            If w <= lng Then
                tabCle(w) = Mid(strCle, i, 1)
                If tabCle(w) = "" Then
                Else
                    tabCle(w) = Asc(tabCle(w))
                End If
            End If
         Next i
    Next y
    For i = 1 To lng
        tabAscii(i) = Asc(tabDecryptage(i))
        tabAscii(i) = tabAscii(i) - Val(tabCle(i))
       
        If tabAscii(i) < 0 Then
            tabAscii(i) = tabAscii(i) + 255
        End If
              
        FctDecryptage = FctDecryptage + Chr(tabAscii(i))
    Next i
    
End Function


