Attribute VB_Name = "ModuleINITIAL"
Option Explicit

Public CheminFichierIni As String
Public CheminFichierLog As String

Private NoCle As Integer

Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" _
    (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" _
    (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, _
    ByVal lpFileName As String) As Long

Public fMainForm As FrmPrincipale
Sub main()

    Set fMainForm = New FrmPrincipale
    
    Dim CheminGraphiques As String
    Dim NoCle As Integer
        
    CheminFichierIni = App.Path & "\Parametres\AppliVb.ini"
    CheminFichierLog = App.Path & "\Parametres\AppliVb.log"
    CheminGraphiques = App.Path & "\Graphiques\"
        
    EcritDansFichierIni "Chemin", "PathGraph", CheminGraphiques, CheminFichierIni
    EcritDansFichierIni "DernierAcces", "DateHeure", Now, CheminFichierLog
        
    ' criture dans le fichier Log de l'utilisateur en cours
    EcritDansFichierIni "DernierAcces", "User", Environ("USERNAME"), CheminFichierLog
    
    ' ATTENTION : sous Windows 98, Environ("USERNAME") ne fonctionne pas et il faut passer par l'API GetUserName
    ' Cette API est fonctionnelle aussi sur les versions plus rcentes de Windows, bien entendu
    ' Vous pouvez trouver l'exemple d'utilisation de cette API dans la FAQ VB sur www.developpez.com
    '  l'adresse : http://vb.developpez.com/faq/?page=Systeme#nom_user
        
    fMainForm.Show
    
End Sub

Public Sub ImageFond(Feuille As Form)
    Feuille.ImgFond.Move 0, 0, Feuille.ScaleWidth, Feuille.ScaleHeight
End Sub

Public Function EcritDansFichierIni(Section As String, Cle As String, _
                                     Valeur As String, Fichier As String) As Long
EcritDansFichierIni = WritePrivateProfileString(Section, Cle, Valeur, Fichier)
End Function

' ces fonctions sont tires de la FAQ VB
Public Function LitDansFichierIni(Section As String, Cle As String, Fichier As String, _
    Optional ValeurParDefaut As String = "") As String

    Dim strReturn As String

    strReturn = String(255, 0)
    GetPrivateProfileString Section, Cle, ValeurParDefaut, strReturn, Len(strReturn), Fichier
    LitDansFichierIni = Left(strReturn, InStr(strReturn, Chr(0)) - 1)

End Function
